﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XamGrid_ConditionalFormatting
{

    public class ViewModel : ObservableModel
    {
        private ObservableCollection<Item> customData;

        public ViewModel()
        {
            CustomData = new ObservableCollection<Item>();

            CustomData.Add(new Item { Name = "Fruits", InStock = true, Price = 30 });
            CustomData.Add(new Item { Name = "Vegetables", InStock = false, Price = 25 });
            CustomData.Add(new Item { Name = "Drinks", InStock = false, Price = 32 });
            CustomData.Add(new Item { Name = "Fruits", InStock = true, Price = 50 });
            CustomData.Add(new Item { Name = "Fruits", InStock = true, Price = 45 });
            CustomData.Add(new Item { Name = "Drinks", InStock = false, Price = 25 });
            CustomData.Add(new Item { Name = "Drinks", InStock = true, Price = 55 });
            CustomData.Add(new Item { Name = "Vegetables", InStock = true, Price = 30 });
        }

        public ObservableCollection<Item> CustomData
        {
            get
            {
                return customData;
            }

            set
            {
                if (value != customData)
                {
                    customData = value;
                    NotifyPropertyChanged();
                }
            }
        }
    }
    public class Item : ObservableModel
    {
        private string name;
        private bool inStock;
        private int price;

        public string Name
        {
            get
            {
                return name;
            }

            set
            {
                if (value != name)
                {
                    name = value;
                    NotifyPropertyChanged();
                }
            }
        }

        public bool InStock
        {
            get
            {
                return inStock;
            }

            set
            {
                if (value != inStock)
                {
                    inStock = value;
                    NotifyPropertyChanged();
                }
            }
        }

        public int Price
        {
            get
            {
                return price;
            }

            set
            {
                if (value != price)
                {
                    price = value;
                    NotifyPropertyChanged();
                }
            }
        }
    }
    public abstract class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        protected void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

}
